variables:
  # This variable should contain reference back to the correct version of scripts.
  # Put the name of your branch here when developing next version of BW CICD scripts.
  # It will be overwritten upon release.
  BW_CICD_VERSION_REF: "version-2.16.0"
  GIT_SUBMODULE_STRATEGY: recursive

default:
  image: node:16
  before_script:
    - git clone --depth 1 --no-tags -b "$BW_CICD_VERSION_REF" --single-branch -c advice.detachedHead=false https://gitlab.com/bindworks/cicd/bw-gitlab-cicd.git /bw-gitlab-cicd
    - /bw-gitlab-cicd/scripts/setup-environment.sh

stages:
  - verify-and-test
  - release

verify-and-test:
  stage: verify-and-test
  timeout: 10m
  script:
    - /bw-gitlab-cicd/scripts/setup-jfrog-npm.sh gitlab JFROG_ACCESS_TOKEN
    - /bw-gitlab-cicd/scripts/perform-node-package-verification.sh
    - env BW_CICD_DRYRUN=yes /bw-gitlab-cicd/scripts/perform-node-package-release.sh
  only:
    - merge_requests
    - master
    - main
  tags:
    - non-docker

master-release:
  stage: release
  timeout: 10m
  script:
    - /bw-gitlab-cicd/scripts/setup-gitlab-push-credentials.sh GITLAB_DEPLOYER_ACCESS_TOKEN
    - /bw-gitlab-cicd/scripts/setup-jfrog-npm.sh gitlab-deployer JFROG_DEPLOYER_ACCESS_TOKEN
    - /bw-gitlab-cicd/scripts/perform-node-package-release.sh
  only:
    - master
    - main
  tags:
    - non-docker
